package com.ruoyi.tc.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.tc.entity.AssetLc;
import com.ruoyi.tc.entity.AssetTask;
import com.ruoyi.tc.entity.po.*;
import com.ruoyi.tc.entity.request.*;
import com.ruoyi.tc.entity.response.AssestTaskXqresponse;
import com.ruoyi.tc.entity.response.AssetTaskResponse;
import com.ruoyi.tc.entity.response.AssetdwHcResponse;
import com.ruoyi.tc.mapper.AssetTaskMapper;
import com.ruoyi.tc.service.*;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 任务主表(AssetTask)表服务实现类
 *
 * @author makejava
 * @since 2024-11-18 13:23:09
 */
@Service("assetTaskService")
public class AssetTaskServiceImpl extends ServiceImpl<AssetTaskMapper, AssetTask> implements AssetTaskService {
    @Resource
    private AssetTaskMapper assetTaskDao;

    @Resource
    private AssetCurrentCpService assetCurrentCpService;

    @Resource
    private AssetBusinessFormCpService assetBusinessFormCpService;

    @Resource
    private AssetSupplyChainCpService assetSupplyChainCpService;


    @Resource
    private AssetBasicNetworkCpService assetBasicNetworkCpService;


    @Resource
    private UnitOtherConcatCpService unitOtherConcatCpService;

    @Resource
    private AssetLcService assetLcService;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public AssetTaskResponse queryById(Integer id) {
        return assetTaskDao.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param assetTask   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<AssetTask> queryByPage(Page<AssetTask> assetTask, AssetTaskPageRequest pageRequest) {
        return assetTaskDao.queryByPage(assetTask, pageRequest);
    }

    /**
     * 新增数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    @Override
    public void insert(AssetTask assetTask) {
        //任务新增
        int id = assetTaskDao.insert(assetTask);
        //新增流程节点
        AssetLc assetLc = new AssetLc();
        assetLc.setTaskId(id);
        assetLc.setXfTime(LocalDateTime.now());
        assetLc.setAssetName("管理员任务下发");
        assetLcService.insert(assetLc);
        String[] parts = assetTask.getDwmc().split(",");
        for (String part : parts) {
            //根据单位名称查询资产
            List<AssetCurrentCpPo> list = assetTaskDao.findByDwmcAssetCurrent(part);
            for (AssetCurrentCpPo assetCurrentResponse : list) {
                assetCurrentResponse.setTaskId(id);
            }
            assetCurrentCpService.saveBatch(list);
            List<AssetBusinessFormCpPo> assetBusinessFormCpResponseList = new ArrayList<>();
            for (AssetCurrentCpPo assetCurrentResponse : list) {
                //新增新监管业务形态
                //根据资产id查询新监管业务形态主表id
                List<AssetBusinessFormCpPo> bussList = assetBusinessFormCpService.findByassetId(assetCurrentResponse.getId());
                if (bussList != null) {
                    for (AssetBusinessFormCpPo assetBusinessFormCpResponse : bussList) {
                        assetCurrentResponse.getXjgywxt().setBusinessId(assetBusinessFormCpResponse.getBusinessId());
                        assetCurrentResponse.getXjgywxt().setAssetId(assetCurrentResponse.getId());
                        assetCurrentResponse.getXjgywxt().setTaskId(id);
                        assetBusinessFormCpResponseList.add(assetCurrentResponse.getXjgywxt());
                    }
                    assetBusinessFormCpService.saveBatch(assetBusinessFormCpResponseList);
                }
                //根据资产id查询供应链主表id-
                List<AssetSupplyChainCpPo> supplyChainList = assetSupplyChainCpService.findByassetId(assetCurrentResponse.getId());
                if (supplyChainList != null) {
                    for (AssetSupplyChainCpPo items : supplyChainList) {
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setSupplyId(items.getSupplyId());
                        items.setTaskId(id);
                        //新增供应链
                    }
                    assetSupplyChainCpService.saveBatch(supplyChainList);
                }
                List<AssetBasicNetworkCpPo> BasicNetworkCpList = assetBasicNetworkCpService.findByassetId(assetCurrentResponse.getId());
                if (BasicNetworkCpList != null) {
                    for (AssetBasicNetworkCpPo items : BasicNetworkCpList) {
                        //根据资产id查询基础网络主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setNetworkId(items.getNetworkId());
                        items.setTaskId(id);
                        //新增基础网络
                    }
                    assetBasicNetworkCpService.saveBatch(BasicNetworkCpList);
                }
                List<UnitOtherConcatCpPo> unitOtherConcatList = unitOtherConcatCpService.findByassetId(assetCurrentResponse.getId());
                if (unitOtherConcatList != null) {
                    for (UnitOtherConcatCpPo items : unitOtherConcatList) {
                        //根据资产id查询其他联系人主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setConcatId(items.getConcatId());
                        items.setTaskId(id);
                        //新增其他联系人
                    }
                    unitOtherConcatCpService.saveBatch(unitOtherConcatList);
                }
            }
        }

    }

    /**
     * 修改数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    @Override
    public int update(AssetTask assetTask) {
        return this.assetTaskDao.update(assetTask);

    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer id) {
        return this.assetTaskDao.deleteById(id) > 0;
    }

    @Override
    public AssetCurrentCpPo taskSh(int taskId, int assetId) {
        AssetCurrentCpPo byId = assetTaskDao.findBytaskIdandAssestId(taskId, assetId);
        byId.setGylxxList(assetSupplyChainCpService.lambdaQuery().eq(AssetSupplyChainCpPo::getAssetId, assetId).eq(AssetSupplyChainCpPo::getDelFlag, "0").eq(AssetSupplyChainCpPo::getTaskId, taskId).list());
        byId.setJcwlList(assetBasicNetworkCpService.lambdaQuery().eq(AssetBasicNetworkCpPo::getAssetId, assetId).eq(AssetBasicNetworkCpPo::getDelFlag, "0").eq(AssetBasicNetworkCpPo::getTaskId, taskId).list());
        byId.setXjgywxt(assetBusinessFormCpService.lambdaQuery().eq(AssetBusinessFormCpPo::getAssetId, assetId).eq(AssetBusinessFormCpPo::getDelFlag, "0").eq(AssetBusinessFormCpPo::getTaskId, taskId).one());
        byId.setOtherConcat(unitOtherConcatCpService.lambdaQuery().eq(UnitOtherConcatCpPo::getAssetId, assetId).eq(UnitOtherConcatCpPo::getDelFlag, "0").eq(UnitOtherConcatCpPo::getTaskId, taskId).list());
        List<Acomma> a1 = new ArrayList<>();
        Arrays.asList(byId.getGlym().split(",")).forEach(x -> {
            Acomma acomma = new Acomma();
            acomma.setKey(x);
            a1.add(acomma);
        });
        byId.setGlymList(a1);
        List<Acomma> a2 = new ArrayList<>();
        Arrays.asList(byId.getGlIp().split(",")).forEach(x -> {
            Acomma acomma = new Acomma();
            acomma.setKey(x);
            a2.add(acomma);
        });
        byId.setGlIpList(a2);
        return byId;
    }

    @Override
    public Page<AssestTaskXqresponse> zcHc(Page<AssestTaskXqresponse> assetTask, AssestTaskXqRequest pageRequest) {
        assetTask.setOptimizeCountSql(false);
        return assetTaskDao.zcHc(assetTask, pageRequest);
    }

    @Override
    public int sh(AssetCurrentShRequest req) {
        AssetLc assetLc = new AssetLc();
        if (req.getStatus()==3) {
            assetLc.setTaskId(req.getTaskId());
            assetLc.setXfTime(LocalDateTime.now());
            assetLc.setAssetName("管理员审核通过");
            assetLcService.insert(assetLc);
        } else if (req.getStatus()==4) {
            assetLc.setTaskId(req.getTaskId());
            assetLc.setAssetName("管理员审核不通过");
            assetLc.setXfTime(LocalDateTime.now());
            assetLcService.insert(assetLc);
        }

        return assetTaskDao.sh(req);
    }

    @Override
    public Page<AssetdwHcResponse> dwHc(Page<AssetdwHcResponse> assetdwHcResponsePage,AssetdwHcRequest req) {

        return assetTaskDao.dwHc(assetdwHcResponsePage,req);
    }
}
